<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPlanningInterfaceResult_v3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPlanningInterfaceResult_v3 extends AbstractStructArrayBase
{
    /**
     * The PlanningInterfaceResult_v3
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PlanningInterfaceResult_v3[]
     */
    public $PlanningInterfaceResult_v3;
    /**
     * Constructor method for ArrayOfPlanningInterfaceResult_v3
     * @uses ArrayOfPlanningInterfaceResult_v3::setPlanningInterfaceResult_v3()
     * @param \StructType\PlanningInterfaceResult_v3[] $planningInterfaceResult_v3
     */
    public function __construct(array $planningInterfaceResult_v3 = array())
    {
        $this
            ->setPlanningInterfaceResult_v3($planningInterfaceResult_v3);
    }
    /**
     * Get PlanningInterfaceResult_v3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PlanningInterfaceResult_v3[]|null
     */
    public function getPlanningInterfaceResult_v3()
    {
        return isset($this->PlanningInterfaceResult_v3) ? $this->PlanningInterfaceResult_v3 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPlanningInterfaceResult_v3 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPlanningInterfaceResult_v3 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePlanningInterfaceResult_v3ForArrayConstraintsFromSetPlanningInterfaceResult_v3(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPlanningInterfaceResult_v3PlanningInterfaceResult_v3Item) {
            // validation for constraint: itemType
            if (!$arrayOfPlanningInterfaceResult_v3PlanningInterfaceResult_v3Item instanceof \StructType\PlanningInterfaceResult_v3) {
                $invalidValues[] = is_object($arrayOfPlanningInterfaceResult_v3PlanningInterfaceResult_v3Item) ? get_class($arrayOfPlanningInterfaceResult_v3PlanningInterfaceResult_v3Item) : sprintf('%s(%s)', gettype($arrayOfPlanningInterfaceResult_v3PlanningInterfaceResult_v3Item), var_export($arrayOfPlanningInterfaceResult_v3PlanningInterfaceResult_v3Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PlanningInterfaceResult_v3 property can only contain items of type \StructType\PlanningInterfaceResult_v3, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PlanningInterfaceResult_v3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PlanningInterfaceResult_v3[] $planningInterfaceResult_v3
     * @return \ArrayType\ArrayOfPlanningInterfaceResult_v3
     */
    public function setPlanningInterfaceResult_v3(array $planningInterfaceResult_v3 = array())
    {
        // validation for constraint: array
        if ('' !== ($planningInterfaceResult_v3ArrayErrorMessage = self::validatePlanningInterfaceResult_v3ForArrayConstraintsFromSetPlanningInterfaceResult_v3($planningInterfaceResult_v3))) {
            throw new \InvalidArgumentException($planningInterfaceResult_v3ArrayErrorMessage, __LINE__);
        }
        if (is_null($planningInterfaceResult_v3) || (is_array($planningInterfaceResult_v3) && empty($planningInterfaceResult_v3))) {
            unset($this->PlanningInterfaceResult_v3);
        } else {
            $this->PlanningInterfaceResult_v3 = $planningInterfaceResult_v3;
        }
        return $this;
    }
    /**
     * Add item to PlanningInterfaceResult_v3 value
     * @throws \InvalidArgumentException
     * @param \StructType\PlanningInterfaceResult_v3 $item
     * @return \ArrayType\ArrayOfPlanningInterfaceResult_v3
     */
    public function addToPlanningInterfaceResult_v3(\StructType\PlanningInterfaceResult_v3 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PlanningInterfaceResult_v3) {
            throw new \InvalidArgumentException(sprintf('The PlanningInterfaceResult_v3 property can only contain items of type \StructType\PlanningInterfaceResult_v3, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PlanningInterfaceResult_v3[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PlanningInterfaceResult_v3|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PlanningInterfaceResult_v3|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PlanningInterfaceResult_v3|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PlanningInterfaceResult_v3|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PlanningInterfaceResult_v3|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PlanningInterfaceResult_v3
     */
    public function getAttributeName()
    {
        return 'PlanningInterfaceResult_v3';
    }
}
